program histogram

implicit none
  
  integer :: n
  character*80 :: infile = 'random1000000.dat'
  character*80 :: outfile = 'hist1000000.dat'
  integer i,ios,k
  real*8 dum
  real*8,allocatable :: z(:)
  
  integer,parameter :: nbin = 20
  real*8,dimension(nbin) :: axis,hist
  real*8 :: h = 0.05d0
  
  print*, 'Reading data from ascii file...'
  open(10,file=infile,status='old')

  write(*,*) 'Examine length of file ...'
  n=0
  do while (0.ne.1)
    read(10,*,iostat=ios) dum
    if (ios.eq.0) then
      n = n + 1 
    else 
      exit
    end if
  end do
  rewind(10)
  print*, 'File consists of', n, 'numbers.'

  allocate(z(n))

  do i=1,n
    read(10,*,iostat=ios) z(i)
  end do
  close(10)
  
  print*, 'Reading done.'
  print*, ''
  print*, 'Computing axis ...'
  
  do i=1,nbin
    axis(i) = real(i-1,8)*h + 0.5d0*h
  end do
  
  print*, 'Done.'
  print*, ''
  print*, 'Computing histogram ...'
  
  hist = 0.0d0
  
  do i=1,n
    k = int(z(i)/h) + 1
    hist(k) = hist(k) + 1
  end do
  
  hist = hist/(h*real(n,8))
  
  open(12,file=outfile,status='replace')
  do i=1,nbin
    write(12,*) axis(i), hist(i)
  end do
  
end program







