program random_numbers

  implicit none

  integer,allocatable :: seed(:)	! Startwerte fuer Zufallszahlengenerator
  integer :: i, k			! Laufvariablen
  integer,parameter :: n = 100	! Anzahl von Zufallszahlen, die erzeugt werden
  real*8,dimension(n) :: z		! Array, in dem ZZ gespeichert werden
  real*8 :: mean,sigma,sigma_t		! Mittelwert, Standardabweichung, richtige Stdabw.
  character*80 :: outfile='random100.dat'	! Datei, in die ZZ geschrieben werden
  
! Initialisiere ZZ-Generator
  call random_seed
! Sag mir wie viele Startwerte Du brauchst
  call random_seed(size=k)
  print*, ' Number of integers for starting value = ', k
  
! Allokiere Speicher
  allocate(seed(k))
  
! Setze Startwerte manuell
  do i=1,k
    print*, 'Type a seed:'
    read(*,*) seed(k)
  end do
  
! Uebergebe Startwerte
  call random_seed(put=seed)
  
! Ziehe n ZZ
  do i=1,n
    call random_number(z(i))
  end do

! Schreibe ZZ in Datei outfile
  open(10,file=outfile,status='replace')
  do i=1,n
    write(10,*) z(i)
  end do
  close(10)
 
! Berechne Mittelwert
  mean = 0.0d0
  do i=1,n
    mean = mean + z(i)
  end do
  mean = mean/real(n,8)
  
! Berechne Standardabweichung
  sigma = 0.0d0
  do i=1,n
    sigma = sigma + (z(i)-mean)**2.0d0
  end do
  sigma = sigma/real(n-1,8)
  sigma = sqrt(sigma)
  
  print*, 'Arithmetic mean: ', mean
  print*, 'Standard deviation:', sigma
  
  sigma_t = sqrt(1.0d0/3.0d0-0.25d0)
  
  print*, 'Deviation of mean:', abs(mean - 0.5d0)/0.5d0
  print*, 'Deviation of sigma:', abs(sigma - sigma_t)/sigma_t
  
end program